IGP Extensions for Deterministic Link
Internet-Draft draft-xiong-lsr-deterministic-link-00
Quan Xiong
ZTE Corporation
China
xiong.quan@zte.com.cn
Xiangyang Zhu
ZTE Corporation
China
zhu.xiangyang@zte.com.cn
Routing
LSR
This document proposes the deterministic link to provide an one-dimensional metric to indicate the deterministic forwarding capabilities at different levels and proposes the deterministic links distribution by IGP extensions.
Introduction
According to [RFC8655], Deterministic Networking (DetNet) operates at the IP layer and delivers service which provides extremely low data loss rates and bounded latency within a network domain. The bounded latency indicates the minimum and maximum end-to-end latency from source to destination and bounded jitter (packet delay variation). [I-D.ietf-detnet-scaling-requirements] has described the enhanced requirements for DetNet enhanced data plane including the deterministic latency guarantees. As per [I-D.ietf-detnet-controller-plane-framework], network nodes need to collect topology information and deterministic capabilities through IGP.
The computing method of end-to-end delay bounds is defined in [RFC9320]. It is the sum of the six delays in bounded latency model. It is the sum of non-queuing delay bound and queuing delay bound. The upper bounds of queuing delay depends on the queuing mechanisms deployed along the path. For example, a link with a queuing mechanism that does not guarantee a bounded delay is a non-deterministic link and a link with a time-based queuing mechanism that can provide deterministic latency guarantee is called a deterministic link. The delay of a deterministic link is consist of the propagation delay of the packet on the link and the queuing delay of the packet at the node. A deterministic link can be a sub-network that provides deterministic transmission or a Point-to-Point (P2P) link.
This document proposes the deterministic link to provide an one-dimensional metric to indicate the deterministic forwarding capabilities at different levels and proposes the deterministic links distribution by IGP extensions.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.
Terminology
The terminology is defined as [RFC8655] and [RFC9320].
Deterministic Link
This document proposes the deterministic link to provide an one-dimensional metric to indicate the deterministic forwarding capabilities at different levels. The deterministic links can shield the differences from underlying forwarding mechanisms.
Deterministic Link Model
As per [RFC9320], six types of delays are defined in timing Model of DetNet. And the DetNet domain can also be modeling as deterministic links and nodes as shown in Figure 1. The deterministic node delay is constant while the deterministic link delay is variable within bounded latency. The end-to-end bounded latency depends on the sum of the deterministic link delay.
- Deterministic Link Delay = Regulation delay + Queuing subsystem delay + Output delay + Link delay + Frame preemption delay
- Deterministic Node Delay = Processing delay

Deterministic Link Model

           DetNet transit node A                 DetNet transit node B
      +-------------------------+             +------------------------+
      |              Queuing    |             |              Queuing   |
      |   Regulator subsystem   |             |   Regulator subsystem  |
      |   +-+-+-+-+ +-+-+-+-+   |             |   +-+-+-+-+ +-+-+-+-+  |
   -->+   | | | | | | | | | +   +------------>+   | | | | | | | | | +  +--->
      |   +-+-+-+-+ +-+-+-+-+   |             |   +-+-+-+-+ +-+-+-+-+  |
      |                         |             |                        |
      +-------------------------+             +------------------------+
      |-->|------->|------->|-->|------------>|-->|------->|------>|-->|-->|
  2,3  4      5        6      1      2,3       4      5        6     1   2,3
          |---- Deterministic Link Delay ---->|

                 Deterministic Links     Deterministic Node
      | A |---------------------------------->| B |----------------------->|

Classification of Deterministic Links
There are a number of deterministic links between deterministic nodes. And each deterministic link provides different level of deterministic forwarding capabilities indicated by Deterministic Class-Type (DT).
Deterministic Class-Type (DT): indicate the set of Traffic Trunks crossing a deterministic link that is governed by a specific set of bounded latency constraints and QoS requirements of deterministic guarantees such as tight jitter,strict latency, loose latency and so on. DT is used for the purposes of deterministic link resource planning, reservation and allocation, deterministic link resource constraint-based routing and admission control. A given Traffic Trunk belongs to the same DT on all links.
The scheduling type of the deterministic link depends on the classification of the queuing solutions. Many variations and extensions of queuing mechanisms have been proposed to guarantee the deterministic latency in DetNet such as ECQF [IEEE 802.1Qdv], Multi-CQF [I-D.dang-queuing-with-multiple-cyclic-buffers], TCQF [I-D.eckert-detnet-tcqf], CSQF [I-D.chen-detnet-sr-based-bounded-latency], TQF [I-D.peng-detnet-packet-timeslot-mechanism], C-SCORE [I-D.joung-detnet-stateless-fair-queuing], EDF[I-D.peng-detnet-deadline-based-forwarding], gLBF [I-D.eckert-detnet-glbf] and so on. [I-D.ietf-detnet-dataplane-taxonomy] has described the classification criteria of the solutions.
[I-D.xiong-lsr-time-resource] has proposed the Time-based Resources Container (TRC) to indicate the capabilities with time-based resources. It can be used for deterministic link to reserve the corresponding scheduling resources such as queuing, buffer and bandwidth to guarantee the deterministic capability.
For example, three deterministic links with guaranteed jitter are supported between the Node A and Node B as following shown.
- deterministic link 1, DT=1 (Jitter Guarantee, Link-scheduling-type=CSQF), bandwidth=20Mbit/s, jitter=10us.
- deterministic link 2, DT=2 (Jitter Guarantee, Link-scheduling-type=TCQF), bandwidth=30Mbit/s, jitter=20us.
- deterministic link 3, DT=3 (Jitter Guarantee, Link-scheduling-type=TQF), bandwidth=40Mbit/s, jitter=30us.
ISIS Extensions of Deterministic Link
This document defines new IS-IS TE sub-TLVs to distribute the deterministic link attributes at TE link and it can be announced in TLVs 22, 23, 141, 222, and 223" registry.
Deterministic Link Sub-TLV
A new IS-IS Deterministic Link Sub-TLV is defined and the format is as shown in the following figure.

Deterministic Link Sub-TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type               |           Length              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |               DT            |     Link Scheduling Type      |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   ~                        Sub-sub-TLV                          ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

where:
- Type: Set to TBD1.
- Length: Contains the total length of the sub-TLV in octets. The Length MUST be at least 8 and MUST be a multiple of 4.
- DT: the value of DT to indicates the set of Traffic Trunks crossing the deterministic link that is governed by a specific set of bounded latency constraints.
- Link Scheduling Type: indicates the type of the queuing or scheduling mechanisms on this deterministic link.
- Sub-sub-TLV: indicates the optional sub-sub-TLV carried in this sub-TLV.
Deterministic Link Maximum Reservable Bandwidth Sub-sub-TLV
A new IS-IS Deterministic Link Maximum Reservable Bandwidth Sub-sub-TLV is defined and the format is as shown in the following figure.

Deterministic Link Maximum Reserved Bandwidth sub-sub-TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type               |           Length              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |               Maximum Reservable Bandwidth                  |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

where:
- Type: Set to TBD2.
- Length: Contains the total length of the sub-sub-TLV in octets. The Length MUST be at least 8 and MUST be a multiple of 4.
- Maximum Reservable Bandwidth: indicates the maximum bandwidth which can be reserved for this deterministic link.
Deterministic Link Available Bandwidth Sub-sub-TLV
A new IS-IS Deterministic Link Available Bandwidth Sub-sub-TLV is defined and the format is as shown in the following figure.

Deterministic Link Available Bandwidth sub-sub-TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type               |           Length              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                  Available Bandwidth                        |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

where:
- Type: Set to TBD3.
- Length: Contains the total length of the sub-sub-TLV in octets. The Length MUST be at least 8 and MUST be a multiple of 4.
- Available Bandwidth: indicates the available bandwidth of this deterministic link.
Deterministic Link Delay Sub-sub-TLV
A new IS-IS Deterministic Link Delay Sub-sub-TLV is defined and the format is as shown in the following figure.

Deterministic Link Delay sub-sub-TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type               |           Length              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |A| Reserved  |           Maximum Deterministic Link Delay    |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Reserved  |           Minimum Deterministic Link Delay    |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Reserved  |  Maximum Deterministic Link Delay Variation   |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

where:
- Type: Set to TBD4.
- Length: Contains the total length of the sub-sub-TLV in octets. The Length MUST be at least 8 and MUST be a multiple of 4.
- A: The A bit represents the Anomalous (A) bit. The A bit is set when the measured value of this parameter exceeds its configured maximum threshold.
- Maximum Deterministic Link Delay: indicates the maximum deterministic link delay value (in microseconds) over a configurable interval, encoded as an integer value.
- Minimum Deterministic Link Delay: indicates the minimum deterministic link delay value (in microseconds) over a configurable interval, encoded as an integer value.
- Maximum Deterministic Link Delay Variation: indicates the maximum deterministic link delay variation value over a configurable interval in microseconds, encoded as an integer value.
OSPF Extensions of Deterministic Links
TBA
Security Considerations
Security considerations for DetNet are covered in the DetNet Architecture [RFC8655] and DetNet controller plane [I-D.ietf-detnet-controller-plane-framework] and DetNet security considerations [RFC9055]. The security considerations specified in [RFC5304] are also applicable to the IGP procedures defined in this document.
IANA Considerations
IANA is requested to register the following sub-TLVs in the "Sub-TLVs for TLVs 22, 23, 141, 222,and 223" registry:

    Type    Description
   ------------------------------------
    TBD1    Deterministic Link Sub-TLV
    TBD2    Deterministic Link Maximum Reservable Bandwidth Sub-sub-TLV
    TBD3    Deterministic Link Available Bandwidth Sub-sub-TLV
    TBD4    Deterministic Link Delay Sub-sub-TLV

Acknowledgements
The authors would like to acknowledge Aihua Liu, Bin Tan for their thorough review and very helpful comments.
References
Normative References
[RFC8655]
[I-D.ietf-detnet-scaling-requirements]
[I-D.ietf-detnet-controller-plane-framework]
[RFC9320]
[I-D.dang-queuing-with-multiple-cyclic-buffers]
[I-D.eckert-detnet-tcqf]
[I-D.chen-detnet-sr-based-bounded-latency]
[I-D.peng-detnet-packet-timeslot-mechanism]
[I-D.joung-detnet-stateless-fair-queuing]
[I-D.peng-detnet-deadline-based-forwarding]
[I-D.eckert-detnet-glbf]
[I-D.ietf-detnet-dataplane-taxonomy]
[I-D.xiong-lsr-time-resource]
[RFC9055]
[RFC5304]